/*============================================================================
//	aPCI-P31A̒`
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	{{[h͂`ohbQPڃ{[hł
//
//==========================================================================*/
#if !defined(_APCI31A_H)
#define _APCI31A_H

#ifndef _TYPEDEF_H
	#include "typedef.h"
#endif

#ifndef _APCISRVS_H
	#include "apcisrvs.h"
#endif

#ifndef _APCICTRL_H
	#include "apcictrl.h"
#endif

/*==========================================*/
/*	aPCI-P31A card's relative port address	*/
/*==========================================*/
#define	APCI31A_PORT_1	0
#define	APCI31A_PORT_2	1
#define	APCI31A_PORT_3	2
#define	APCI31A_PORT_4	3

/*==================*/
/*	Miscellaneous	*/
/*==================*/
#define	APCI31A_MAX_SLOTS	16			/* Maximum number of slots */
#define APCI31A_MAX_PORTS	4			/* Maximum number of user ports */

/*==============*/
/*	Device ID	*/
/*==============*/
#define	APCI31A_BOARD_ID	0x9131		/* pci bus device id */
#define	APCI31A_VENDOR_ID	0x136c		/* pci bus vendor id */
										/* our device id */
#define	APCI31A_DEVICE_ID	( ( DWORD )APCI31A_BOARD_ID\
							| ( ( DWORD )APCI31A_VENDOR_ID << 16 ) )

#endif
