//============================================================================
//	apci31aw.pas
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.11 Date 1999/08/23
//
//============================================================================

unit apci31aw;

interface

uses
	Windows;

//-------------------------------------
// װޒ萔
//-------------------------------------
const
	APCI31A_SUCCESS							= 0;	// I
	APCI31A_ERR_SYSTEM					= 1;	// GetLastError sĂ
	APCI31A_ERR_NO_DEVICE				= 2;	// gp\޲Ȃ
	APCI31A_ERR_IN_USE					= 3;	// w肳ꂽ޲͎gp
	APCI31A_ERR_INVALID_SLOT		= 4;	// Ș_ۯĔԍw肵
	APCI31A_ERR_RESOURCE				= 5;	// ؿװ
	APCI31A_ERR_INVALID_PORT		= 6;	// ߰Ăv
	APCI31A_ERR_INVALID_ARGUMENT= 7;	// Ȉv
	APCI31A_ERR_NO_CREATE				= 8;	// ޲شĂĂ܂
	APCI31A_ERR_WRAPDLL					=Dword(-1);		// ׯ߰֐װ
//-------------------------------------
// ߰Ĕԍ萔
//-------------------------------------
	APCI31A_PORT_1 = 0;
	APCI31A_PORT_2 = 1;
	APCI31A_PORT_3 = 2;
	APCI31A_PORT_4 = 3;
//-------------------------------------
// ̑萔
//-------------------------------------
	APCI31A_DLL_NAME 	= 'apci31a.dll';	// DLĻٖ
	APCI31A_MAX_PORTS	= 4;							// ߰Đ
	APCI31A_MAX_SLOTS	= 16;							// őۯĐ
	APCI31A_DEVICE_ID	= $136c9131;			// ޲ID
	APCI31A_SLOT_AUTO	= $ffff;					// AutoSlotl
//-------------------------------------
// ؿ\
//-------------------------------------
	APCI31A_MAX_MEM	=	 9;
	APCI31A_MAX_IO	= 20;
	APCI31A_MAX_IRQ	=	 7;
	APCI31A_MAX_DMA	=	 7;

type
	TAPCI31ARESOURCE = record
		dwNumMemWindows:																DWORD;	// س޳(gp)
		dwMemBase:			array [1 .. APCI31A_MAX_MEM] of	DWORD;	// س޳ްڽ(gp)
		dwMemLength:		array [1 .. APCI31A_MAX_MEM] of	DWORD;	// س޳(gp)
		dwMemAttrib:		array [1 .. APCI31A_MAX_MEM] of	DWORD;	// س޳(gp)
		dwNumIOPorts:																		DWORD;	// I/O߰Đ
		dwIOPortBase:		array [1 .. APCI31A_MAX_IO] of	DWORD;	// I/O߰ްڽ
		dwIOPortLength: array [1 .. APCI31A_MAX_IO] of	DWORD;	// I/O߰Ē
		dwNumIRQs:																			DWORD;	// IRQ(gp)
		dwIRQRegisters: array [1 .. APCI31A_MAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwIRQAttrib:		array [1 .. APCI31A_MAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwNumDMAs:																			DWORD;	// DMAِ(gp)
		dwDMALst:				array [1 .. APCI31A_MAX_DMA] of	DWORD;	// DMAؽ(gp)
		dwDMAAttrib:		array [1 .. APCI31A_MAX_DMA] of	DWORD;	// DMAّؽ(gp)
		dwReserved1:		array [1 .. 3] of								DWORD;	// \(gp)
	end;
//-------------------------------------
// J֐
//-------------------------------------
// DLL ۰
function Apci31awDllOpen: Boolean;
// DLL ۰
function Apci31awDllClose: Boolean;
// aPCI-P31A DLL,޲ײްްޮݔԍ擾
function Apci31awGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
// CӂaPCI-P31A̎gp錾
function Apci31awCreate(var pwLogSlot:WORD): Boolean;
// CӂaPCI-P31A̎gpJ
function Apci31awClose(wLogSlot:WORD): Boolean;
// ؿ擾
function Apci31awGetResource(wLogSlot:WORD; var pResInfo:TAPCI31ARESOURCE): Boolean;
// Cӂ߰Ăް
function Apci31awInPort(wLogSlot:WORD; dwLogPort:DWORD; var pbInValue:BYTE): Boolean;
// Cӂ߰Ăްo
function Apci31awOutPort(wLogSlot:WORD; dwLogPort:DWORD; bOutValue:BYTE): Boolean;
// aPCI-P31A̴װ
function Apci31awGetLastError(wLogSlot:WORD): DWORD;
// ۰ذ̒l擾
function Apci31awGetSwitchValue(wLogSlot:WORD; var pdwSwitchValue:DWORD): Boolean;

//-------------------------------------
// (STATIC)ϐȂ
//-------------------------------------
implementation

{$J+}	// ^t萔̕ύX\߲׎w
const
	hDLL: THandle = 0;

type
	TApci31aGetVersion = function(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): BOOL; stdcall;
	TApci31aCreate = function(var pwLogSlot:WORD): BOOL; stdcall;
	TApci31aClose = function(wLogSlot:WORD): BOOL; stdcall;
	TApci31aGetResource = function(wLogSlot:WORD; var pres:TAPCI31ARESOURCE): BOOL; stdcall;
	TApci31aInPort = function(wLogSlot:WORD; dwLogPort:DWORD; var pbInValue:BYTE): BOOL; stdcall;
	TApci31aOutPort = function(wLogSlot:WORD; dwLogPort:DWORD; bOutValue:BYTE): BOOL; stdcall;
	TApci31aGetLastError = function(wLogSlot:WORD): DWORD; stdcall;
	TApci31aGetSwitchValue = function(wLogSlot:WORD; var pdwSwitchValue:DWORD): BOOL; stdcall;

// DLL ߰Ċ֐ڽ̊i[ϐ
var
	pApci31aGetVersion: TApci31aGetVersion;
	pApci31aCreate: TApci31aCreate;
	pApci31aClose: TApci31aClose;
	pApci31aGetResource: TApci31aGetResource;
	pApci31aInPort: TApci31aInPort;
	pApci31aOutPort: TApci31aOutPort;
	pApci31aGetLastError: TApci31aGetLastError;
	pApci31aGetSwitchValue: TApci31aGetSwitchValue;

function Apci31awGetDllExportFunc: Boolean; forward;

{$J-}

//============================================================================
// 		apci31a.dll۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Apci31awDllOpen: Boolean;
begin
	Result := False;
	if hDLL = 0 then begin
		hDLL := LoadLibrary(APCI31A_DLL_NAME);
		if hDLL <> 0 then begin
			Result := Apci31awGetDllExportFunc;
			if Result <> True then
				Apci31awDllClose;			// DLL֐擾ɎŝDLL۰
		end;
	end;
end;
//============================================================================
// 		apci31a.dll۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Apci31awDllClose: Boolean;
begin
	Result := False;
	if hDLL <> 0 then begin
		Result := FreeLibrary(hDLL);
		if Result = True then begin
			hDLL := 0;
		end;
	end;
end;
//============================================================================
// 		aPCI-P31A DLL,޲ײްްޮݔԍ擾
// 		pdwDllVersion			DLLްޮݔԍi[̈ւ߲
//				pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci31awGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci31aGetVersion(pdwDllVersion, pdwDriverVersion)
end;
//============================================================================
// 		aPCI-P31A̔Cӂ޲̎gp錾
// 		pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l  True
//				s False
//============================================================================
function Apci31awCreate(var pwLogSlot:WORD): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci31aCreate(pwLogSlot)
end;
//============================================================================
// 		aPCI-P31A̔Cӂ޲̎gpJ
// 		wLogSlot ޲̘_ۯĔԍ
// ߂l  True
//				s False
//============================================================================
function Apci31awClose(wLogSlot:WORD): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci31aClose(wLogSlot)
end;
//============================================================================
// 		w޲ؿ擾
// 		wLogSlot	ؿ擾޲̘_ۯĔԍ
//				pResInfo	ؿi[\߲̂
// ߂l  True
//				s False
//============================================================================
function Apci31awGetResource(wLogSlot:WORD; var pResInfo:TAPCI31ARESOURCE): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci31aGetResource(wLogSlot, pResInfo)
end;
//============================================================================
// 		Cӂ߰Ăް
// 		wLogSlot	͂޲̘_ۯĔԍ
//				dwLogPort	͂_߰
//				pbInValue ްi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci31awInPort(wLogSlot:WORD; dwLogPort:DWORD; var pbInValue:BYTE): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci31aInPort(wLogSlot, dwLogPort, pbInValue)
end;
//============================================================================
// 		Cӂ߰Ăްo
// 		wLogSlot	o͂޲̘_ۯĔԍ
//				dwLogPort	o͂_߰
//				bOutValue o͂ް
// ߂l  True
//				s False
//============================================================================
function Apci31awOutPort(wLogSlot:WORD; dwLogPort:DWORD; bOutValue:BYTE): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci31aOutPort(wLogSlot, dwLogPort, bOutValue)
end;
//============================================================================
// 		aPCI-P31A̴װ
// 		wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//============================================================================
function Apci31awGetLastError(wLogSlot:WORD): DWORD;
begin
	if hDLL = 0 then Result := APCI31A_ERR_WRAPDLL
	else Result := pApci31aGetLastError(wLogSlot)
end;
//============================================================================
// 		۰ذ̒l擾
// 		wLogSlot				۰ذ̒l擾޲̘_ۯĔԍ
// 				pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci31awGetSwitchValue(wLogSlot:WORD; var pdwSwitchValue:DWORD): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci31aGetSwitchValue(wLogSlot, pdwSwitchValue)
end;
//---------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  True
//		  	s False
//---------------------------------------------------------------------------
function Apci31awGetDllExportFunc: Boolean;
begin
	Result := False;
	// Apci31aGetVersion ̱ڽ擾
	pApci31aGetVersion := GetProcAddress(hDLL, 'Apci31aGetVersion');
	if @pApci31aGetVersion = nil then Exit;
	// Apci31aCreate ̱ڽ擾
	pApci31aCreate := GetProcAddress(hDLL, 'Apci31aCreate');
	if @pApci31aCreate = nil then Exit;
	// Apci31aClose ̱ڽ擾
	pApci31aClose := GetProcAddress(hDLL, 'Apci31aClose');
	if @pApci31aClose = nil then Exit;
	// Apci31aGetResource ̱ڽ擾
	pApci31aGetResource := GetProcAddress(hDLL, 'Apci31aGetResource');
	if @pApci31aGetResource = nil then Exit;
	// Apci31aInPort ̱ڽ擾
	pApci31aInPort := GetProcAddress(hDLL, 'Apci31aInPort');
	if @pApci31aInPort = nil then Exit;
	// Apci31aOutPort ̱ڽ擾
	pApci31aOutPort := GetProcAddress(hDLL, 'Apci31aOutPort');
	if @pApci31aOutPort = nil then Exit;
	// Apci31aGetLastError ̱ڽ擾
	pApci31aGetLastError := GetProcAddress(hDLL, 'Apci31aGetLastError');
	if @pApci31aGetLastError = nil then Exit;
	// Apci31aGetSwitchValue ̱ڽ擾
	pApci31aGetSwitchValue := GetProcAddress(hDLL, 'Apci31aGetSwitchValue');
	if @pApci31aGetSwitchValue = nil then Exit;
	// SĂ DLL ߰Ċ֐ڽ擾nj
	Result := True;
end;

end.

